/*============================================================================
: LiFe
:   MPS-
:  
: .. 
 : .. 
 : 1.03.2005
==============================================================================*/
#include <assert.h>
#include <conio.h>
#include <dos.h>
#include <io.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "_main.h"

//=============   =======================================
//-------------  -----------------------------------------------------------
typedef enum keyWordCod{NAME,ROWS,COLUMNS,RHS,ENDATA,error} keyWordCod_t ; //   

typedef struct nameCat_{	//   
	keyWordCod_t	keyWordCod;
   char           keyWord[MAX_KEYWORD_LENGTH];
}nameCat_t;

typedef struct rowCat_{	//   
	int				rowNo;						//    A
	int 				rowType;						//  
   char				rowName[NAME_LENGTH];	// - 
}rowCat_t;

typedef struct colCat_{	//   
	int	colNo;									//    
	char	colName[NAME_LENGTH];				// - 
}colCat_t;
//-------------  -------------------------------------------------------
static float A[MAX_M][MAX_N];	//   ( 0-  -  -,
										//	 0-  - . )

static nameCat_t _nameCat[CAT_LENGTH]={	//   
	{NAME,	"NAME"},
   {ROWS,	"ROWS"},
   {COLUMNS,"COLUMNS"},
   {RHS,		"RHS"},
   {ENDATA,	"ENDATA"}
};

static char problem_name[NAME_LENGTH];		//    

static rowCat_t	_rowCat[MAX_CAT_LENGTH];//  .   0   !
static int 			_rowCatLen=0;				//    (   0)

static colCat_t	_colCat[MAX_CAT_LENGTH];//  .   0    
static int			_colCatLen=0;				//    (   0)
//=============  =======================================================
void _skipComments(FILE*);
void _skipSpace(FILE*);
void _nameSect(FILE*);
void _rowsSect(FILE*);
void _columnsSect(FILE*);
void _rhsSect(FILE*);
void _appendCol(FILE*);
void _procLine(FILE*);
void _procLineRhs(FILE*);
int  _find_colNo(char*);
int  _find_rowNo(char*);
//============= M A I N ========================================================
void main(){
	_read_MPS();
  	_print_MPS();
   getch();
};
//=============   =============================================
//------------- _read_MPS() ----------------------------------------------------
static void _read_MPS(){// 
FILE *stream;		// 
int eof=0;			//   
char kWord[MAX_KEYWORD_LENGTH]; 	//   
keyWordCod_t kwCod;					//    
int i;

   stream = fopen(_INPUT,"r");// 
	if (stream==NULL){
		printf("Cannot open input file.\n\nPress ENTER");
      getchar();
      abort();
   };

   while(!eof){	//   
	   _skipComments(stream);
	   fscanf(stream, "%s",kWord);
     	kwCod=error;
      for(i=0;i<CAT_LENGTH;i++){
      	if(strcmp(kWord,_nameCat[i].keyWord)==0){
         	kwCod=_nameCat[i].keyWordCod;
            break;
         };
      };

      switch(kwCod){
		case NAME:
			_nameSect(stream);break;
      case ROWS:
      	_rowsSect(stream);break;
      case COLUMNS:
      	_columnsSect(stream);break;
      case RHS:
      	_rhsSect(stream);break;
      case ENDATA:
      	eof=1;break;
      case error:
			printf("Error: wrong keyword '%s'.\n\nPress ENTER",kWord);
   	   getchar();
      	abort();
      default:
			printf("System Error!\n\nPress ENTER");
   	   getchar();
      	abort();
   	};
   };
};
//----------------------------- _skipComments ----------------------------------
//      (,   '*')
static void _skipComments(FILE *stream){
int c;
	while((c=getc(stream))=='*'){
   	while(getc(stream)!=10);
      fscanf(stream, "\n");
	};
   ungetc(c,stream);
};
//----------------------------- _nameSect --------------------------------------
//     NAME
static void _nameSect(FILE *stream){
	fscanf(stream, "%s",problem_name);
   while(getc(stream)!=10); ungetc(10,stream);
};
//----------------------------- _rowsSect --------------------------------------
//     ROWS
static void _rowsSect(FILE *stream){
int c;

	while(getc(stream)!=10);
	while(1){	//   
	   _skipComments(stream);

   	if((c=getc(stream))!=' '){
	      ungetc(c,stream);
      	return;
      };

      _rowCat[_rowCatLen].rowType=getc(stream);
		fscanf(stream, "%s",_rowCat[_rowCatLen].rowName);
		while(getc(stream)!=10);
      if(_rowCat[_rowCatLen].rowType!='N'){
      	_rowCat[_rowCatLen].rowNo=_rowCatLen+1;
   	}else{
      	_rowCat[_rowCatLen].rowNo=0;
      };
     	_rowCatLen++;
   };
};
//----------------------------- _columnsSect -----------------------------------
//     COLUMNS
static void _columnsSect(FILE *stream){
   int c;
	fpos_t beginPos; //    

   while(getc(stream)!=10); //     
 	fgetpos(stream,&beginPos); //      

  	while(1){ //  
   	_skipComments(stream);
      if(getc(stream)!=' ')
      	break;
     	_appendCol(stream);
   };

   fsetpos(stream,&beginPos);

	while(1){ //  
		_skipComments(stream);
      if((c=getc(stream))!=' ')
      	break;
     	_procLine(stream);
   };

   ungetc(c,stream); //   ""
};
//***************_appendCol*******************************************************/**/
//     
void _appendCol(FILE *stream){
	int c;
   _skipComments(stream);

   while((c=getc(stream))!=' ');ungetc(c,stream); //     

   fscanf(stream, "%s",_colCat[_colCatLen].colName);

  	_colCat[_colCatLen].colNo=_colCatLen+1;
	_colCatLen++;

   if(_colCatLen>1 && strcmp(_colCat[_colCatLen-2].colName,_colCat[_colCatLen-1].colName)==0)
   		_colCatLen--;
	while(getc(stream)!=10); //    
};
//***************_procLine*******************************************************
//    COLUMNS    
void _procLine(FILE *stream){
   int c;
   int i,j; 	//   -  
	char ident[NAME_LENGTH]; //  (   )
   int eol=0; 	//   
   float aij;		//  -  

	fscanf(stream,"%s",ident);
   j=_find_colNo(ident);

	while(!eol){
		fscanf(stream,"%s",ident);
	   i=_find_rowNo(ident);
      fscanf(stream,"%f",&aij);
      A[i][j]=aij;
      _skipSpace(stream);
      if((c=getc(stream))==10)
      	eol=1;
      else
      	ungetc(c,stream);
   };
};
//----------------------------- _rhsSect ---------------------------------------
//     RHS
static void _rhsSect(FILE *stream){
	int c;
  	while(getc(stream)!=10); //     
	while(1){
		_skipComments(stream);
      if((c=getc(stream))!=' ')
 		break;
     	_procLineRhs(stream);
   };
  	ungetc(c,stream); //   ""
};
//***************_procLineRhs*******************************************************
//    RHS    
void _procLineRhs(FILE *stream){
   int c;
   int i; 	// a  -  
   char ident[NAME_LENGTH]; //  ( )
   int eol=0; 	//   
   float bj;		//  -  

	fscanf(stream,"%s",ident);

	while(!eol){
      fscanf(stream,"%s",ident);
      i=_find_rowNo(ident);
      fscanf(stream,"%f",&bj);
      A[i][0]=bj;
      _skipSpace(stream);
      if((c=getc(stream))!=10)
      	ungetc(c,stream);
      else
      	eol=1;
   }; 
};
//############# _find_colNo ####################################################
//        
static int _find_colNo(char* colName){
	int j;
	for(j=0;j<=_colCatLen;j++)
   	if(strcmp(colName,_colCat[j].colName)==0)
      	return _colCat[j].colNo;
	printf("\n\tERROR!!! Undefined colName\n\tPress ENTER\n");
   getchar();
   abort();
   return 0;
};
//############# _find_rowNo ####################################################
//        
static _find_rowNo(char* rowName){
	int j;
	for(j=0;j<=_rowCatLen;j++)
   	if(strcmp(rowName,_rowCat[j].rowName)==0)
      	return _rowCat[j].rowNo;
	printf("ERROR!!! Undefined rowName\n\tPress ENTER\n");
   getchar();
   abort();
   return 0;
};
//***************_skipSpace*******************************************************
//        (   )
void _skipSpace(FILE *stream){
	int c;
	while((c=getc(stream))!=10 && c<=32);
   ungetc(c,stream);
};

   //------------- _print_MPS() ---------------------------------------------------
static void _print_MPS(){// 
int i,j;

	printf("\n");
   for(i=0;i<_rowCatLen;i++)
   for(j=0;j<_colCatLen+1;j++)
   {
    printf("%.1f ",A[i][j]);
    if(j==_colCatLen)
    printf("\n");
   };
//
   printf("\n\tThe problem: %s\n\n",problem_name);//   

  	for(i=1;i<_rowCatLen;i++){  // 
   	for(j=1;j<_colCatLen+1;j++){
   		printf("+ (%.1f)*X%d ",A[i][j],j);
   	};

      	if(_rowCat[i-1].rowType=='L')
    			printf(" <= %.1f\n",A[i][0]);

    		if(_rowCat[i-1].rowType=='E')
    			printf(" = %.1f\n",A[i][0]);

    		if(_rowCat[i-1].rowType=='G')
    			printf(" >=%.1f\n",A[i][0]);

    if(j==_colCatLen)
    	printf("\n");
	}

   printf("\n"); //   
   for(i=0;i<_rowCatLen;i++){
   	if(_rowCat[i].rowType=='N'){
      	printf("%s = ",_rowCat[i].rowName);
      }
   }
   for(j=1;j<_colCatLen+1;j++){ //   
   	printf("+ (%.1f)*X%d ",A[0][j],j);
   }

   printf("\n\n\t\aDone!!!\n\tPress ENTER\n");
   getchar();
   abort();
};

